unit Unit1;

interface

uses
  SysUtils, Classes, HTTPApp, HTTPProd, DB, DBClient, DBWeb, DSProd,
  DBXpress, FMTBcd, DBXpressWeb, SqlExpr;

type
  TWebModule1 = class(TWebModule)
    ppTeste1: TPageProducer;
    dstpTeste2: TDataSetTableProducer;
    cdsTeste2: TClientDataSet;
    dsppTeste3: TDataSetPageProducer;
    cdsTeste3: TClientDataSet;
    Conexao: TSQLConnection;
    qryCustomer: TSQLQuery;
    qryCustomerCUST_NO: TIntegerField;
    qryCustomerCUSTOMER: TStringField;
    qryCustomerCONTACT_FIRST: TStringField;
    qryCustomerCONTACT_LAST: TStringField;
    qryCustomerPHONE_NO: TStringField;
    qryCustomerADDRESS_LINE1: TStringField;
    qryCustomerADDRESS_LINE2: TStringField;
    qryCustomerCITY: TStringField;
    qryCustomerSTATE_PROVINCE: TStringField;
    qryCustomerCOUNTRY: TStringField;
    qryCustomerPOSTAL_CODE: TStringField;
    qryCustomerON_HOLD: TStringField;
    SqlQryTPCustomer: TSQLQueryTableProducer;
    procedure WebModule1waPadraoAction(Sender: TObject; Request: TWebRequest;
      Response: TWebResponse; var Handled: Boolean);
    procedure ppTeste1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure WebModule1waTeste3Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.dfm}

procedure TWebModule1.WebModule1waPadraoAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  i: Integer;
begin
  //monta o cabealho da pgina
  Response.Content := '<h3 style=color:#0000FF>Meu primeiro ' + 
    'aplicativo webbroker</h3>';

  //monta a lista completa das propriedades que uma Requisio
  //pode oferecer, com seus respectivos valores
  Response.Content := Response.Content +
    '<p><font color=red><b>Propriedades da requisio:</b></font><br>' +
    '<b>Method:</b> ' + Request.Method + '<br>' +
    '<b>ProtocolVersion:</b> ' + Request.ProtocolVersion + '<br>' +
    '<b>URL:</b> ' + Request.URL + '<br>' +
    '<b>Query:</b> ' + Request.Query + '<br>' +
    '<b>PathInfo:</b> ' + Request.PathInfo + '<br>' +
    '<b>PathTranslated:</b> ' + Request.PathTranslated + '<br>' +
    '<b>Authorization:</b> ' + Request.Authorization + '<br>' +
    '<b>CacheControl:</b> ' + Request.CacheControl + '<br>'+
    '<b>Cookie:</b> ' + Request.Cookie + '<br>' +
    '<b>Accept:</b> ' + Request.Accept + '<br>' +
    '<b>From:</b> ' + Request.From + '<br>' +
    '<b>Host:</b> ' + Request.Host + '<br>' +
    '<b>Referer:</b> ' + Request.Referer + '<br>' +
    '<b>UserAgent:</b> ' + Request.UserAgent + '<br>' +
    '<b>ContentEncoding:</b> ' + Request.ContentEncoding + '<br>' +
    '<b>ContentType:</b> ' + Request.ContentType + '<br>' +
    '<b>ContentVersion:</b> ' + Request.ContentVersion + '<br>' +
    '<b>Content:</b> ' + Request.Content + '<br>' +
    '<b>Connection:</b> ' + Request.Connection + '<br>' +
    '<b>DerivedFrom:</b> ' + Request.DerivedFrom + '<br>' +
    '<b>Title:</b> ' + Request.Title + '<br>' +
    '<b>RemoteAddr:</b> ' + Request.RemoteAddr + '<br>' +
    '<b>RemoteHost:</b> ' + Request.RemoteHost + '<br>' +
    '<b>ScriptName:</b> ' + Request.ScriptName + '<br>' +
    '<b>InternalPathInfo:</b> ' + Request.InternalPathInfo + '<br>' +
    '<b>InternalScriptName:</b> ' + Request.InternalScriptName + '</p>';

  //exibe a lista de aes disponveis na instancia corrente do webmodule
  Response.Content := Response.Content +
    '<p><font color=green><b>Lista de Aes disponveis:</b></font><br>';
  for i := 0 to Self.Actions.Count-1 do
    Response.Content := Response.Content +
      IntToStr(i) + ': ' + Self.Actions[i].Name + ' - ' + 
      Self.Actions[i].PathInfo + '<br>';
  Response.Content := Response.Content + '</p>';
end;

procedure TWebModule1.ppTeste1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
begin
  if TagString = 'hora' then
    ReplaceText := TimeToStr(Time) + ' hrs';
end;

procedure TWebModule1.WebModule1waTeste3Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  ID: String; //armazenar o cdigo passado por parmetro
begin
  //verifica se veio o parmetro ID na URL
  if Request.QueryFields.Values['id'] <> '' then
  begin
    //se veio, recupera o seu valor
    ID := Request.QueryFields.Values['id'];
    //filtra o ClientDataSet para que encontre o cliente
    //especificado. Neste ponto, tambm poderamos executar
    //uma instruo SQL no banco de dados, por exemplo.
    cdsTeste3.Filtered := False;
    cdsTeste3.Filter   := 'CustNo = ' + ID;
    cdsTeste3.Filtered := True;
    //se no encontrou nada, alerta o usurio
    if cdsTeste3.IsEmpty then
      response.Content := '<b>Cliente no localizado!</b><br><br>' +
                          'Voc informou: ' + ID
    else
      //e se encontrou, pega o retorno do prprio dsppTeste3
      response.Content := dsppTeste3.Content;
  end
  else
    //se no veio parmetro, alerta o usurio
    Response.Content := '<b>Cliente no especificado!</b>'
    //obs: este alerta poderia tambm vir de um arquivo ou
    //PageProducer padro para erros, e seria algo como:
    //Response.Content := ppClienteNaoEspecificado.Content;
end;

end.
